import Vue from 'vue'
import axios from 'axios'

import App from './App'
import router from './router'
import store from './store'
import io from 'socket.io-client';
import VueSocketio from 'vue-socket.io'
if (!process.env.IS_WEB) Vue.use(require('vue-electron'))
Vue.http = Vue.prototype.$http = axios
Vue.config.productionTip = false
const SocketInstance = io.connect('http://localhost:3000', {
    query: {
        token: window.localStorage.getItem('auth')
    }
});

Vue.use(new VueSocketio({
    debug: true,
    connection: SocketInstance,
    vuex: {
        store,
        actionPrefix: 'SOCKET_',
        mutationPrefix: 'SOCKET_'
    },
}),store);
//Vue.use(VueSocketio, 'http://localhost:3000', store)

/* eslint-disable no-new */
new Vue({
  components: { App },
  router,
  store,
  template: '<App/>'
}).$mount('#app')
