import Vue from 'vue'
var fs = require('fs'); // 载入fs模块.
var checkFlag = 0
const state = {
    connect: false,
    data: 0,
    report: null,
    pressure: null,
    pressCop: null,
    standArea: null,
    ratio: null,
    pressImageInfo: {},
    isConnect: 1,
    isResetPressure: 1,
    bodyBlanceData: [],
    footPressureInfo: {},
    scanAbnormarl: false,
    stopScan: 2,
    standTime: 0,
    reStartStatus:2,  // 回复重新进入扫描状态 0 成功 1 失败 2 初始状态
    collectionStatus:0,  // 0 隐藏  1 搜集数据中 2 数据计算中
    equipmentFault:0,  // 设备故障 0 代表没有故障 1 代表故障
    balanceStatus : '',
    soundStatus:'',
    languageInfo:[],
    socketConnect:2 ,// socket连接状态 0 为失败 1 成功 2 初始状态 3 连接后断开状态码,
    device_code:'', //设备编码
    pressureNullStatus:0,
    blueConnectStatus:0, // 蓝牙设备连接状态码
    blueDisConnectStatus:0, // 蓝牙设备断开连接状态码
    blueMacAddress:'', // pad蓝牙设备mac地址
    uploadIpInfoStatus:0, // 连接上wifi 重新上报ip信息状态码
    connectWifiProcessStatus:0,
    blueServerStatus:'',
    macAddress:"mac_address",
    checkCameraStatus:"",
    checkCameraImgUrl:null
}



const actions = {

    socket_report: (context, report) => {
        let temp = immutable.fromJS(report).toJS();
        let temp2 = getBalanceScore(temp,state.bodyBlanceData);
        temp2.file_address.foot_stl_data = null
        sync.state.report = temp2
        // sendDataToPad(temp2,'/padreport')
        let payload = {
            report: temp2,
        }

        //context.dispatch('addScanData', payload, {root: true})
    },
    // 上报之前存在本地的错误统计
    uploadLocalError:({commit}) =>{
        readErrorFile()
    }
}

const mutations = {
    // 蓝牙服务开启成功
    SOCKET_BLUECONNECT:(state,result)=>{
        state.blueServerStatus = result
    },
    // 发现null 修改状态码
    SOCKET_REPORTISNULL:(state,result)=>{
        state.pressureNullStatus ++
    },
    SOCKET_SOCKETDISCONNECT:(state,result)=>{
        state.socketConnect = result
    },
    SOCKET_SOCKETCONNECT:(state,result)=>{
        state.socketConnect = result
    },
    LANGUAGE_INFO:(state,result)=>{
        state.languageInfo = result
    },
    SOCKET_CONNECT: (state, status) => {
        state.connect = true
    },
    SOCKET_reconTest: (state, status) => {
        console.log(status)
    },



}


const getters = {
    blueServerStatus:state=>state.blueServerStatus,
    uploadIpInfoStatus:state=>state.uploadIpInfoStatus,
    blueMacAddress:state=>state.blueMacAddress,
    blueConnectStatus:state=>state.blueConnectStatus,
    blueDisConnectStatus:state=>state.blueDisConnectStatus,
    checkCameraImgUrl:state=>state.checkCameraImgUrl,
    checkCameraStatus:state=>state.checkCameraStatus,
    pressureNullStatus:state=>state.pressureNullStatus,
    socketConnect:state=>state.socketConnect,
    languageInfo:state=>state.languageInfo,
    soundStatus:state=>state.soundStatus,
    macAddress:state=>state.macAddress,
    balanceStatus:state=>{
        return state.balanceStatus
    },
    langs:state=>{
        return state.langs
    },
    scanningPressure: state => {
        return state.pressure
    },
    scanAbnormarl: state => {
        return state.scanAbnormarl
    },
    isConnect: state => {
        return state.isConnect
    },
    equipmentFault:state=>{
        return state.equipmentFault
    },
    standTime: state => {
        return state.standTime
    },
    body_blance_data: state => {
        return state.bodyBlanceData
    },
    isResetPressure: state => {
        return state.isResetPressure
    },
    footPressureInfo: state => {
        return state.footPressureInfo
    },
    collectionStatus:state => {
        return state.collectionStatus
    },
    footStlData: state => {
        if (state.report === null || state.report.file_address === null) {
            return null;
        }
        return null;
        //return state.report.file_address.double_stl_src
    },
    rollingStatus: state => {
        if (state.report === null) {
            return {
                leftMsg: '-',
                rightMsg: '-'
            }
        }
        let leftFootAd = state.report.foot_presure_info.left_foot_ad
        let leftLh = leftFootAd.lh_ad
        let leftMh = leftFootAd.mh_ad
        let leftTotal = leftLh + leftMh;
        let leftLhPercent = Math.round((leftLh / leftTotal) * 100);
        let leftMhPercent = 100 - leftLhPercent;
        let leftMsg = '中立'
        if (leftMhPercent >= 55) {   // 足跟外翻
            leftMsg = '外翻'
        }
        if (leftLhPercent >= 55) {   // 足跟内翻
            leftMsg = '内翻'
        }
        if(leftLh == 0) {
            // 外翻
            leftMsg = '外翻'
        } else if(leftMh==0) {
            leftMsg = '内翻'
        }
       /* if (leftPercent1 < 0.55 && leftPercent2 < 0.55) {
            leftMsg = '中立'
        } else if (leftPercent2 >= 0.55) {
            leftMsg = '外翻'
        } else {
            leftMsg = '内翻'
        }*/
        let rightFootAd = state.report.foot_presure_info.right_foot_ad
        let rightLh = rightFootAd.lh_ad
        let rightMh = rightFootAd.mh_ad
        let rightTotal = rightLh + rightMh;
        let rightLhPercent = Math.round((rightLh / rightTotal) * 100);
        let rightMhPercent = 100 - rightLhPercent;
        let rightMsg = '中立'
        if (rightMhPercent >= 55) {   // 足跟外翻
            rightMsg = '外翻'
        }
        if (rightLhPercent >= 55) {   // 足跟内翻
            rightMsg = '内翻'
        }
        if(rightLh == 0) {
            // 外翻
            rightMsg = '外翻'
        } else if(rightMh==0) {
            rightMsg = '内翻'
        }
      /*  let rightPercent1 = (rightLh / (rightLh + rightMh)).toFixed(2)
        let rightPercent2 = (rightMh / (rightLh + rightMh)).toFixed(2)
        let rightMsg
        if (rightPercent1 < 0.55 && rightPercent2 < 0.55) {
            rightMsg = '中立'
        } else if (rightPercent2 >= 0.55) {
            rightMsg = '外翻'
        } else {
            rightMsg = '内翻'
        }*/
        return {
            leftMsg: leftMsg,
            rightMsg: rightMsg
        }
    },
    archStatus: state => {
        if (state.report === null) {
            return {
                leftMsg: '-',
                rightMsg: '-'
            }
        }
        // 左脚
        let leftTotalAd = state.report.foot_presure_info.left_foot_area.foot_total_area
        let leftBAd = state.report.foot_presure_info.left_foot_area.b_area;
        let leftArchPercent =  Math.round(leftBAd / leftTotalAd*100);
        // 右脚
        let rightTotalAd = state.report.foot_presure_info.right_foot_area.foot_total_area
        let rightBAd = state.report.foot_presure_info.right_foot_area.b_area;
        let rightArchPercent =  Math.round(rightBAd / rightTotalAd*100);
        return {
            leftMsg: getArchMsg(leftArchPercent),
            rightMsg: getArchMsg(rightArchPercent)
        }
    },
    footPressureRatio: state => {
        if (state.report === null) {
            if (state.ratio === null) {
                return {
                    leftRatio: 0,
                    rightRatio: 0
                }
            }
            return {
                leftRatio: state.ratio.pressRatio.general * 100,
                rightRatio: 100 - state.ratio.pressRatio.general * 100
            }
        }
        let leftFootAd = state.report.foot_presure_info.left_foot_ad
        let rightFootAd = state.report.foot_presure_info.right_foot_ad
        let leftFootTotalAd = leftFootAd.foot_total_ad;
        let rightFootTotalAd = rightFootAd.foot_total_ad;
        let leftRatio = leftFootTotalAd / (leftFootTotalAd + rightFootTotalAd) * 100;
        let rightRatio = rightFootTotalAd / (leftFootTotalAd + rightFootTotalAd) * 100;
        return {
            leftRatio: leftRatio,
            rightRatio: rightRatio
        }
    },
    lineInfo: state => {
        if (state.ratio === null) {
            return null
        }
        return state.ratio.line
    },
    gravityPoint: state => {
        if (state.pressCop === null) {
            return null
        }
        return state.pressCop
    },
    report: state => state.report,
    pressImageInfo: state => state.pressImageInfo,
    device_code:state=>state.device_code
}

function getArchMsg(index) {
    console.log(index)
    if (index < 23) {
        return '高足弓'
    }else if (index >= 23 && index<=31) {
        return '中足弓'
    }else{
        return '扁平足'
    }

}

const expand = 1;
// const expand = 3;
const areaNames = ['t1', 't2', 'm1', 'm2', 'm3', 'm4', 'm5', 'mf', 'lh', 'mh'];
const balanceData = ["35,31", "35,31", "34,31", "34,31", "35,31", "35,31", "34,31", "34,31", "35,31", "35,31", "35,31", "34,31", "35,31", "34,31", "34,31", "35,31", "34,31", "34,31", "34,31", "35,31", "35,31", "35,31", "34,31", "34,31", "34,31", "35,31", "34,31", "34,31", "34,31", "34,31", "34,31", "35,31", "34,31", "34,31", "34,31", "34,31", "35,31", "35,31", "34,31", "34,31", "34,31", "35,31", "34,31", "34,31", "34,31", "34,31", "35,32", "34,32", "34,32", "34,33", "34,33", "34,33", "34,33", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,31", "34,31", "34,31", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,33", "34,33", "34,33", "34,33", "34,33", "34,33", "34,33", "34,33", "34,33", "34,33", "34,33", "34,33", "34,33", "34,33", "34,33", "34,33", "34,33", "34,33", "34,33", "34,33", "34,33", "34,33", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,32", "34,33", "34,33", "34,33", "34,33", "34,32", "34,32", "34,32", "34,33", "32,37", "31,40", "31,42", "31,42", "31,42", "31,41", "32,40", "32,39", "33,38", "33,37", "33,36", "34,36", "34,36", "34,36", "34,36", "34,36"
]

function mockFootPressure() {
    return [{"x":171,"y":99,"value":randomFrom()},{"x":180,"y":99,"value":randomFrom()},{"x":135,"y":108,"value":randomFrom()},{"x":144,"y":108,"value":104},{"x":153,"y":108,"value":73},{"x":162,"y":108,"value":126},{"x":171,"y":108,"value":randomFrom()},{"x":180,"y":108,"value":randomFrom()},{"x":189,"y":108,"value":randomFrom()},{"x":396,"y":108,"value":67},{"x":405,"y":108,"value":randomFrom()},{"x":414,"y":108,"value":randomFrom()},{"x":432,"y":108,"value":randomFrom()},{"x":117,"y":117,"value":randomFrom()},{"x":126,"y":117,"value":98},{"x":135,"y":117,"value":145},{"x":144,"y":117,"value":90},{"x":153,"y":117,"value":73},{"x":162,"y":117,"value":117},{"x":171,"y":117,"value":130},{"x":180,"y":117,"value":120},{"x":189,"y":117,"value":151},{"x":198,"y":117,"value":76},{"x":369,"y":117,"value":71},{"x":378,"y":117,"value":90},{"x":387,"y":117,"value":randomFrom()},{"x":396,"y":117,"value":randomFrom()},{"x":405,"y":117,"value":randomFrom()},{"x":414,"y":117,"value":97},{"x":423,"y":117,"value":107},{"x":432,"y":117,"value":120},{"x":441,"y":117,"value":89},{"x":450,"y":117,"value":103},{"x":99,"y":126,"value":128},{"x":108,"y":126,"value":randomFrom()},{"x":117,"y":126,"value":randomFrom()},{"x":126,"y":126,"value":randomFrom()},{"x":135,"y":126,"value":119},{"x":162,"y":126,"value":96},{"x":171,"y":126,"value":133},{"x":180,"y":126,"value":133},{"x":189,"y":126,"value":145},{"x":198,"y":126,"value":84},{"x":369,"y":126,"value":64},{"x":378,"y":126,"value":randomFrom()},{"x":387,"y":126,"value":randomFrom()},{"x":396,"y":126,"value":141},{"x":405,"y":126,"value":76},{"x":414,"y":126,"value":62},{"x":423,"y":126,"value":61},{"x":432,"y":126,"value":98},{"x":441,"y":126,"value":71},{"x":450,"y":126,"value":111},{"x":459,"y":126,"value":63},{"x":90,"y":135,"value":randomFrom},{"x":99,"y":135,"value":randomFrom()},{"x":108,"y":135,"value":94},{"x":126,"y":135,"value":77},{"x":135,"y":135,"value":107},{"x":162,"y":135,"value":79},{"x":171,"y":135,"value":69},{"x":180,"y":135,"value":107},{"x":189,"y":135,"value":133},{"x":198,"y":135,"value":87},{"x":378,"y":135,"value":61},{"x":387,"y":135,"value":59},{"x":396,"y":135,"value":114},{"x":405,"y":135,"value":142},{"x":414,"y":135,"value":64},{"x":423,"y":135,"value":57},{"x":441,"y":135,"value":63},{"x":450,"y":135,"value":107},{"x":459,"y":135,"value":68},{"x":99,"y":144,"value":105},{"x":108,"y":144,"value":79},{"x":117,"y":144,"value":86},{"x":126,"y":144,"value":84},{"x":135,"y":144,"value":97},{"x":144,"y":144,"value":94},{"x":153,"y":144,"value":82},{"x":162,"y":144,"value":116},{"x":171,"y":144,"value":137},{"x":180,"y":144,"value":138},{"x":189,"y":144,"value":153},{"x":198,"y":144,"value":143},{"x":207,"y":144,"value":91},{"x":369,"y":144,"value":68},{"x":378,"y":144,"value":89},{"x":387,"y":144,"value":82},{"x":396,"y":144,"value":64},{"x":405,"y":144,"value":52},{"x":414,"y":144,"value":62},{"x":423,"y":144,"value":57},{"x":432,"y":144,"value":53},{"x":441,"y":144,"value":62},{"x":450,"y":144,"value":69},{"x":459,"y":144,"value":51},{"x":99,"y":153,"value":111},{"x":108,"y":153,"value":95},{"x":117,"y":153,"value":103},{"x":126,"y":153,"value":99},{"x":135,"y":153,"value":105},{"x":144,"y":153,"value":75},{"x":153,"y":153,"value":62},{"x":162,"y":153,"value":93},{"x":171,"y":153,"value":132},{"x":180,"y":153,"value":120},{"x":189,"y":153,"value":147},{"x":198,"y":153,"value":139},{"x":207,"y":153,"value":120},{"x":369,"y":153,"value":100},{"x":378,"y":153,"value":120},{"x":387,"y":153,"value":132},{"x":396,"y":153,"value":115},{"x":405,"y":153,"value":87},{"x":414,"y":153,"value":117},{"x":423,"y":153,"value":111},{"x":432,"y":153,"value":98},{"x":441,"y":153,"value":111},{"x":450,"y":153,"value":94},{"x":459,"y":153,"value":70},{"x":99,"y":162,"value":90},{"x":108,"y":162,"value":90},{"x":117,"y":162,"value":96},{"x":126,"y":162,"value":111},{"x":135,"y":162,"value":132},{"x":144,"y":162,"value":112},{"x":153,"y":162,"value":106},{"x":162,"y":162,"value":142},{"x":171,"y":162,"value":139},{"x":180,"y":162,"value":132},{"x":189,"y":162,"value":147},{"x":198,"y":162,"value":144},{"x":207,"y":162,"value":142},{"x":369,"y":162,"value":114},{"x":378,"y":162,"value":132},{"x":387,"y":162,"value":145},{"x":396,"y":162,"value":137},{"x":405,"y":162,"value":126},{"x":414,"y":162,"value":156},{"x":423,"y":162,"value":128},{"x":432,"y":162,"value":114},{"x":441,"y":162,"value":139},{"x":450,"y":162,"value":144},{"x":459,"y":162,"value":106},{"x":99,"y":171,"value":90},{"x":108,"y":171,"value":106},{"x":117,"y":171,"value":131},{"x":126,"y":171,"value":121},{"x":135,"y":171,"value":134},{"x":144,"y":171,"value":110},{"x":153,"y":171,"value":113},{"x":162,"y":171,"value":140},{"x":171,"y":171,"value":149},{"x":180,"y":171,"value":135},{"x":189,"y":171,"value":144},{"x":198,"y":171,"value":148},{"x":207,"y":171,"value":150},{"x":369,"y":171,"value":112},{"x":378,"y":171,"value":143},{"x":387,"y":171,"value":149},{"x":396,"y":171,"value":135},{"x":405,"y":171,"value":136},{"x":414,"y":171,"value":133},{"x":423,"y":171,"value":128},{"x":432,"y":171,"value":114},{"x":441,"y":171,"value":119},{"x":450,"y":171,"value":138},{"x":459,"y":171,"value":107},{"x":99,"y":180,"value":122},{"x":108,"y":180,"value":115},{"x":117,"y":180,"value":131},{"x":126,"y":180,"value":131},{"x":135,"y":180,"value":136},{"x":144,"y":180,"value":114},{"x":153,"y":180,"value":105},{"x":162,"y":180,"value":143},{"x":171,"y":180,"value":149},{"x":180,"y":180,"value":138},{"x":189,"y":180,"value":147},{"x":198,"y":180,"value":150},{"x":207,"y":180,"value":151},{"x":369,"y":180,"value":124},{"x":378,"y":180,"value":151},{"x":387,"y":180,"value":136},{"x":396,"y":180,"value":139},{"x":405,"y":180,"value":150},{"x":414,"y":180,"value":141},{"x":423,"y":180,"value":146},{"x":432,"y":180,"value":128},{"x":441,"y":180,"value":125},{"x":450,"y":180,"value":132},{"x":459,"y":180,"value":115},{"x":468,"y":180,"value":68},{"x":477,"y":180,"value":84},{"x":99,"y":189,"value":86},{"x":108,"y":189,"value":101},{"x":117,"y":189,"value":114},{"x":126,"y":189,"value":112},{"x":135,"y":189,"value":117},{"x":144,"y":189,"value":88},{"x":153,"y":189,"value":96},{"x":162,"y":189,"value":120},{"x":171,"y":189,"value":120},{"x":180,"y":189,"value":113},{"x":189,"y":189,"value":122},{"x":198,"y":189,"value":118},{"x":207,"y":189,"value":116},{"x":369,"y":189,"value":98},{"x":378,"y":189,"value":102},{"x":387,"y":189,"value":115},{"x":396,"y":189,"value":112},{"x":405,"y":189,"value":121},{"x":414,"y":189,"value":121},{"x":423,"y":189,"value":126},{"x":432,"y":189,"value":129},{"x":441,"y":189,"value":125},{"x":450,"y":189,"value":135},{"x":459,"y":189,"value":104},{"x":468,"y":189,"value":59},{"x":477,"y":189,"value":81},{"x":90,"y":198,"value":126},{"x":99,"y":198,"value":156},{"x":108,"y":198,"value":122},{"x":117,"y":198,"value":132},{"x":126,"y":198,"value":128},{"x":135,"y":198,"value":130},{"x":144,"y":198,"value":114},{"x":153,"y":198,"value":randomFrom()},{"x":162,"y":198,"value":randomFrom()},{"x":171,"y":198,"value":randomFrom()},{"x":180,"y":198,"value":126},{"x":189,"y":198,"value":132},{"x":198,"y":198,"value":124},{"x":207,"y":198,"value":124},{"x":369,"y":198,"value":116},{"x":378,"y":198,"value":131},{"x":387,"y":198,"value":130},{"x":396,"y":198,"value":132},{"x":405,"y":198,"value":140},{"x":414,"y":198,"value":141},{"x":423,"y":198,"value":144},{"x":432,"y":198,"value":146},{"x":441,"y":198,"value":142},{"x":450,"y":198,"value":147},{"x":459,"y":198,"value":120},{"x":468,"y":198,"value":81},{"x":477,"y":198,"value":110},{"x":486,"y":198,"value":48},{"x":90,"y":207,"value":138},{"x":99,"y":207,"value":153},{"x":108,"y":207,"value":119},{"x":117,"y":207,"value":131},{"x":126,"y":207,"value":122},{"x":135,"y":207,"value":121},{"x":144,"y":207,"value":103},{"x":153,"y":207,"value":113},{"x":162,"y":207,"value":130},{"x":171,"y":207,"value":124},{"x":180,"y":207,"value":109},{"x":189,"y":207,"value":111},{"x":198,"y":207,"value":92},{"x":207,"y":207,"value":93},{"x":369,"y":207,"value":82},{"x":378,"y":207,"value":113},{"x":387,"y":207,"value":138},{"x":396,"y":207,"value":119},{"x":405,"y":207,"value":120},{"x":414,"y":207,"value":133},{"x":423,"y":207,"value":133},{"x":432,"y":207,"value":137},{"x":441,"y":207,"value":131},{"x":450,"y":207,"value":142},{"x":459,"y":207,"value":121},{"x":468,"y":207,"value":74},{"x":477,"y":207,"value":109},{"x":486,"y":207,"value":64},{"x":90,"y":216,"value":128},{"x":99,"y":216,"value":176},{"x":108,"y":216,"value":140},{"x":117,"y":216,"value":131},{"x":126,"y":216,"value":121},{"x":135,"y":216,"value":129},{"x":144,"y":216,"value":104},{"x":153,"y":216,"value":104},{"x":162,"y":216,"value":119},{"x":171,"y":216,"value":120},{"x":189,"y":216,"value":100},{"x":198,"y":216,"value":80},{"x":369,"y":216,"value":71},{"x":378,"y":216,"value":96},{"x":387,"y":216,"value":111},{"x":396,"y":216,"value":102},{"x":405,"y":216,"value":108},{"x":414,"y":216,"value":130},{"x":423,"y":216,"value":132},{"x":432,"y":216,"value":133},{"x":441,"y":216,"value":127},{"x":450,"y":216,"value":138},{"x":459,"y":216,"value":120},{"x":468,"y":216,"value":81},{"x":477,"y":216,"value":110},{"x":486,"y":216,"value":87},{"x":90,"y":225,"value":141},{"x":99,"y":225,"value":155},{"x":108,"y":225,"value":135},{"x":117,"y":225,"value":135},{"x":126,"y":225,"value":119},{"x":135,"y":225,"value":117},{"x":144,"y":225,"value":98},{"x":153,"y":225,"value":83},{"x":162,"y":225,"value":76},{"x":378,"y":225,"value":74},{"x":387,"y":225,"value":91},{"x":396,"y":225,"value":94},{"x":405,"y":225,"value":105},{"x":414,"y":225,"value":108},{"x":423,"y":225,"value":126},{"x":432,"y":225,"value":125},{"x":441,"y":225,"value":127},{"x":450,"y":225,"value":148},{"x":459,"y":225,"value":145},{"x":468,"y":225,"value":90},{"x":477,"y":225,"value":142},{"x":486,"y":225,"value":81},{"x":99,"y":234,"value":144},{"x":108,"y":234,"value":113},{"x":117,"y":234,"value":123},{"x":126,"y":234,"value":103},{"x":135,"y":234,"value":97},{"x":144,"y":234,"value":88},{"x":153,"y":234,"value":75},{"x":162,"y":234,"value":89},{"x":387,"y":234,"value":61},{"x":396,"y":234,"value":72},{"x":405,"y":234,"value":95},{"x":414,"y":234,"value":91},{"x":423,"y":234,"value":108},{"x":432,"y":234,"value":95},{"x":441,"y":234,"value":88},{"x":450,"y":234,"value":120},{"x":459,"y":234,"value":117},{"x":468,"y":234,"value":120},{"x":477,"y":234,"value":131},{"x":486,"y":234,"value":107},{"x":99,"y":243,"value":128},{"x":108,"y":243,"value":131},{"x":117,"y":243,"value":121},{"x":126,"y":243,"value":112},{"x":135,"y":243,"value":97},{"x":405,"y":243,"value":64},{"x":414,"y":243,"value":83},{"x":423,"y":243,"value":110},{"x":432,"y":243,"value":102},{"x":441,"y":243,"value":56},{"x":450,"y":243,"value":72},{"x":459,"y":243,"value":196},{"x":468,"y":243,"value":110},{"x":477,"y":243,"value":142},{"x":486,"y":243,"value":54},{"x":108,"y":252,"value":121},{"x":117,"y":252,"value":130},{"x":126,"y":252,"value":117},{"x":135,"y":252,"value":83},{"x":414,"y":252,"value":70},{"x":423,"y":252,"value":98},{"x":432,"y":252,"value":119},{"x":441,"y":252,"value":104},{"x":450,"y":252,"value":95},{"x":459,"y":252,"value":56},{"x":468,"y":252,"value":94},{"x":477,"y":252,"value":120},{"x":108,"y":261,"value":118},{"x":117,"y":261,"value":137},{"x":126,"y":261,"value":116},{"x":135,"y":261,"value":83},{"x":144,"y":261,"value":89},{"x":414,"y":261,"value":66},{"x":423,"y":261,"value":92},{"x":432,"y":261,"value":111},{"x":441,"y":261,"value":105},{"x":450,"y":261,"value":127},{"x":459,"y":261,"value":80},{"x":468,"y":261,"value":58},{"x":477,"y":261,"value":52},{"x":108,"y":270,"value":107},{"x":117,"y":270,"value":136},{"x":126,"y":270,"value":139},{"x":135,"y":270,"value":96},{"x":144,"y":270,"value":89},{"x":153,"y":270,"value":79},{"x":414,"y":270,"value":62},{"x":423,"y":270,"value":59},{"x":432,"y":270,"value":82},{"x":441,"y":270,"value":96},{"x":450,"y":270,"value":122},{"x":459,"y":270,"value":69},{"x":117,"y":279,"value":144},{"x":126,"y":279,"value":121},{"x":135,"y":279,"value":102},{"x":144,"y":279,"value":97},{"x":153,"y":279,"value":89},{"x":414,"y":279,"value":75},{"x":423,"y":279,"value":101},{"x":432,"y":279,"value":98},{"x":441,"y":279,"value":80},{"x":450,"y":279,"value":116},{"x":459,"y":279,"value":77},{"x":117,"y":288,"value":109},{"x":126,"y":288,"value":124},{"x":135,"y":288,"value":101},{"x":144,"y":288,"value":94},{"x":153,"y":288,"value":78},{"x":162,"y":288,"value":96},{"x":414,"y":288,"value":59},{"x":423,"y":288,"value":70},{"x":432,"y":288,"value":99},{"x":441,"y":288,"value":75},{"x":450,"y":288,"value":92},{"x":459,"y":288,"value":56},{"x":126,"y":297,"value":114},{"x":135,"y":297,"value":86},{"x":144,"y":297,"value":90},{"x":153,"y":297,"value":96},{"x":162,"y":297,"value":95},{"x":414,"y":297,"value":70},{"x":423,"y":297,"value":100},{"x":432,"y":297,"value":107},{"x":441,"y":297,"value":77},{"x":450,"y":297,"value":87},{"x":144,"y":306,"value":76},{"x":153,"y":306,"value":113},{"x":162,"y":306,"value":108},{"x":171,"y":306,"value":91},{"x":396,"y":306,"value":60},{"x":405,"y":306,"value":67},{"x":414,"y":306,"value":89},{"x":423,"y":306,"value":87},{"x":432,"y":306,"value":103},{"x":441,"y":306,"value":48},{"x":450,"y":306,"value":74},{"x":144,"y":315,"value":92},{"x":153,"y":315,"value":138},{"x":162,"y":315,"value":132},{"x":171,"y":315,"value":111},{"x":180,"y":315,"value":91},{"x":387,"y":315,"value":69},{"x":396,"y":315,"value":65},{"x":405,"y":315,"value":88},{"x":414,"y":315,"value":85},{"x":423,"y":315,"value":93},{"x":432,"y":315,"value":21},{"x":441,"y":315,"value":56},{"x":450,"y":315,"value":72},{"x":153,"y":324,"value":120},{"x":162,"y":324,"value":126},{"x":171,"y":324,"value":124},{"x":180,"y":324,"value":107},{"x":189,"y":324,"value":103},{"x":387,"y":324,"value":97},{"x":396,"y":324,"value":88},{"x":405,"y":324,"value":92},{"x":414,"y":324,"value":95},{"x":423,"y":324,"value":91},{"x":432,"y":324,"value":71},{"x":450,"y":324,"value":60},{"x":153,"y":333,"value":126},{"x":162,"y":333,"value":124},{"x":171,"y":333,"value":119},{"x":180,"y":333,"value":113},{"x":189,"y":333,"value":112},{"x":198,"y":333,"value":82},{"x":369,"y":333,"value":71},{"x":378,"y":333,"value":93},{"x":387,"y":333,"value":104},{"x":396,"y":333,"value":94},{"x":405,"y":333,"value":98},{"x":414,"y":333,"value":92},{"x":423,"y":333,"value":44},{"x":432,"y":333,"value":63},{"x":153,"y":342,"value":126},{"x":162,"y":342,"value":129},{"x":171,"y":342,"value":128},{"x":180,"y":342,"value":125},{"x":189,"y":342,"value":126},{"x":198,"y":342,"value":125},{"x":369,"y":342,"value":110},{"x":378,"y":342,"value":110},{"x":387,"y":342,"value":106},{"x":396,"y":342,"value":102},{"x":405,"y":342,"value":103},{"x":414,"y":342,"value":91},{"x":423,"y":342,"value":78},{"x":153,"y":351,"value":132},{"x":162,"y":351,"value":142},{"x":171,"y":351,"value":148},{"x":180,"y":351,"value":138},{"x":189,"y":351,"value":150},{"x":198,"y":351,"value":154},{"x":207,"y":351,"value":142},{"x":351,"y":351,"value":82},{"x":360,"y":351,"value":104},{"x":369,"y":351,"value":142},{"x":378,"y":351,"value":133},{"x":387,"y":351,"value":136},{"x":396,"y":351,"value":116},{"x":405,"y":351,"value":120},{"x":414,"y":351,"value":101},{"x":423,"y":351,"value":67},{"x":162,"y":360,"value":123},{"x":171,"y":360,"value":135},{"x":180,"y":360,"value":130},{"x":189,"y":360,"value":134},{"x":198,"y":360,"value":140},{"x":207,"y":360,"value":152},{"x":351,"y":360,"value":100},{"x":360,"y":360,"value":115},{"x":369,"y":360,"value":135},{"x":378,"y":360,"value":136},{"x":387,"y":360,"value":129},{"x":396,"y":360,"value":118},{"x":405,"y":360,"value":113},{"x":414,"y":360,"value":100},{"x":423,"y":360,"value":66},{"x":153,"y":369,"value":129},{"x":162,"y":369,"value":130},{"x":171,"y":369,"value":149},{"x":180,"y":369,"value":143},{"x":189,"y":369,"value":149},{"x":198,"y":369,"value":164},{"x":207,"y":369,"value":180},{"x":216,"y":369,"value":88},{"x":351,"y":369,"value":134},{"x":360,"y":369,"value":134},{"x":369,"y":369,"value":164},{"x":378,"y":369,"value":152},{"x":387,"y":369,"value":144},{"x":396,"y":369,"value":130},{"x":405,"y":369,"value":118},{"x":414,"y":369,"value":92},{"x":423,"y":369,"value":59},{"x":153,"y":378,"value":141},{"x":162,"y":378,"value":148},{"x":171,"y":378,"value":135},{"x":180,"y":378,"value":150},{"x":189,"y":378,"value":164},{"x":198,"y":378,"value":169},{"x":207,"y":378,"value":194},{"x":216,"y":378,"value":95},{"x":351,"y":378,"value":153},{"x":360,"y":378,"value":152},{"x":369,"y":378,"value":169},{"x":378,"y":378,"value":151},{"x":387,"y":378,"value":147},{"x":396,"y":378,"value":133},{"x":405,"y":378,"value":116},{"x":414,"y":378,"value":79},{"x":153,"y":387,"value":128},{"x":162,"y":387,"value":147},{"x":171,"y":387,"value":145},{"x":180,"y":387,"value":111},{"x":189,"y":387,"value":160},{"x":198,"y":387,"value":171},{"x":207,"y":387,"value":174},{"x":342,"y":387,"value":78},{"x":351,"y":387,"value":168},{"x":360,"y":387,"value":159},{"x":369,"y":387,"value":171},{"x":378,"y":387,"value":154},{"x":387,"y":387,"value":151},{"x":396,"y":387,"value":129},{"x":405,"y":387,"value":117},{"x":414,"y":387,"value":82},{"x":153,"y":396,"value":102},{"x":162,"y":396,"value":134},{"x":171,"y":396,"value":148},{"x":180,"y":396,"value":140},{"x":189,"y":396,"value":156},{"x":198,"y":396,"value":167},{"x":207,"y":396,"value":166},{"x":351,"y":396,"value":174},{"x":360,"y":396,"value":180},{"x":369,"y":396,"value":171},{"x":378,"y":396,"value":160},{"x":387,"y":396,"value":153},{"x":396,"y":396,"value":134},{"x":405,"y":396,"value":110},{"x":414,"y":396,"value":68},{"x":153,"y":405,"value":79},{"x":162,"y":405,"value":98},{"x":171,"y":405,"value":143},{"x":180,"y":405,"value":144},{"x":189,"y":405,"value":154},{"x":198,"y":405,"value":155},{"x":207,"y":405,"value":94},{"x":351,"y":405,"value":156},{"x":360,"y":405,"value":190},{"x":369,"y":405,"value":174},{"x":378,"y":405,"value":160},{"x":387,"y":405,"value":152},{"x":396,"y":405,"value":118},{"x":405,"y":405,"value":87},{"x":180,"y":414,"value":99},{"x":189,"y":414,"value":112},{"x":198,"y":414,"value":97},{"x":351,"y":414,"value":85},{"x":360,"y":414,"value":229},{"x":369,"y":414,"value":192},{"x":378,"y":414,"value":164},{"x":387,"y":414,"value":141},{"x":360,"y":423,"value":138},{"x":369,"y":423,"value":109},{"x":378,"y":423,"value":94}]
}
function randomFrom(lowerValue = 180,upperValue = 250)
{
    return Math.floor(Math.random() * (upperValue - lowerValue + 1) + lowerValue);
}
function getHeatmapOption(report) {
    let result = {};
    if (report && report.foot_pressure_img_info) {
        let leftFootPressure = report.foot_pressure_img_info.left_foot_presure || [];
        let rightFootPressure = report.foot_pressure_img_info.right_foot_presure || [];
        let gravityPoint = report.foot_pressure_img_info.gravity_point || {};
        let leftFootArea = report.foot_pressure_img_info.left_foot_area || {};
        let rightFootArea = report.foot_pressure_img_info.right_foot_area || {};
        let xAxi = [];
        let yAxi = [];
        let pointsMid = [];
        let pointsExpand = [];
        let pointsDra = [];
        let xDra = [];
        let yDra = [];
        forEach(leftFootPressure, (obj) => {
            let x = Number(obj.split(',')[0]);
            let y = Number(obj.split(',')[1]);
            let press = Number(obj.split(',')[2]);
            xAxi.push(x);
            yAxi.push(y);
            pointsMid.push({x: x, y: y, value: press});
        });
        forEach(rightFootPressure, (obj) => {
            let x = Number(obj.split(',')[0]);
            let y = Number(obj.split(',')[1]);
            let press = Number(obj.split(',')[2]);
            xAxi.push(x);
            yAxi.push(y);
            pointsMid.push({x: x, y: y, value: press});
        });
        let minX = min(xAxi) * expand;
        let maxX = max(xAxi) * expand;
        let minY = min(yAxi) * expand;
        let maxY = max(yAxi) * expand;
        if (minX != undefined && maxX != undefined && minY != undefined && maxY != undefined &&
            gravityPoint.center_point) {
            let centerX = Number(gravityPoint.center_point.split(',')[0]) * expand;
            let centerY = Number(gravityPoint.center_point.split(',')[1]) * expand;
            let distanceX = Math.max(Math.abs(minX - centerX), Math.abs(maxX - centerX));
            let distanceY = Math.max(Math.abs(minY - centerY), Math.abs(maxY - centerY));
            minX = centerX - distanceX - 1 * expand;
            maxX = centerX + distanceX + 1 * expand;
            minY = centerY - distanceY - 1 * expand;
            maxY = centerY + distanceY + 1 * expand;
            let centerDistanceX = distanceX / 3;
            let centerDistanceY = distanceY / 3;
            // console.log("minX -->>", minX)
            // console.log("maxX -->>", maxX)
            // console.log("minY -->>", minY)
            // console.log("maxY -->>", maxY)
            let dis = Math.floor(expand / 2);
            for (var x = minX; x <= maxX; x++) {
                for (var yl = minY; yl <= maxY; yl++) {
                    y = minY + maxY - yl
                    // for (var y = maxY; y >= minY; y--) {
                    if (x < minX + dis || x > maxX - dis || y < minY + dis || y > maxY - dis) {
                        pointsDra.push([x, yl, 0]);
                    } else {
                        let sum = 0;
                        for (var i = -dis; i <= dis; i++) {
                            for (var j = -dis; j <= dis; j++) {
                                let xOri = Math.floor((x + i) / expand);
                                let yOri = Math.floor((y + j) / expand);
                                let findResult = find(pointsMid, {x: xOri, y: yOri}) ?
                                    find(pointsMid, {x: xOri, y: yOri})["value"] : 0;
                                sum = sum + findResult;
                            }
                        }
                        pointsDra.push([x, yl, sum / (expand * expand)]);
                    }
                }
                console.log("x----", x, "y-----", y);
                xDra.push(x);
            }
            for (var y = minY; y <= maxY; y++) {
                yDra.push(y);
            }
            let series = [];
            // 热力图
            series.push({
                name: 'Gaussian',
                type: 'heatmap',
                data: pointsDra,
                itemStyle: {
                    emphasis: {
                        borderColor: '#00000000',
                        borderWidth: 0
                    }
                },
                progressive: 1000,
                animation: false
            });
            // 几何中心点
            result.center = [centerX, centerY];
            series.push({
                data: [[centerX, centerY], [centerX, centerY + centerDistanceY]],
                type: 'line',
                lineStyle: {
                    color: 'gray',
                    width: 2,
                }
            });
            series.push({
                data: [[centerX, centerY], [centerX, centerY - centerDistanceY]],
                type: 'line',
                lineStyle: {
                    color: 'gray',
                    width: 2,
                }
            });
            series.push({
                data: [[centerX, centerY], [centerX - centerDistanceX, centerY]],
                type: 'line',
                lineStyle: {
                    color: 'gray',
                    width: 2,
                }
            });
            series.push({
                data: [[centerX, centerY], [centerX + centerDistanceX, centerY]],
                type: 'line',
                lineStyle: {
                    color: 'gray',
                    width: 2,
                }
            });
            // 区域
            let leftAreaList = getAreaPointList(leftFootArea)
            let rightAreaList = getAreaPointList(rightFootArea)
            let areaList = leftAreaList.concat(rightAreaList);
            if (areaList.length > 0) {
                areaList.map(obj => {
                    series.push({
                        data: obj.points,
                        type: 'line',
                        lineStyle: {
                            color: 'black',
                            width: 1,
                        },
                        showSymbol: false,
                    });
                    series.push({
                        data: [obj.center],
                        type: 'scatter',
                        showSymbol: false,
                        symbolSize: 1,
                        label: {
                            show: true,
                            position: 'inside',
                            formatter: obj.name,
                            fontSize: 12,
                            color: 'black',
                            fontWeight: 'bold',
                        },
                    });
                })
            }
            // 重心
            if (gravityPoint.body_gravity_point && gravityPoint.body_gravity_point.split(',') &&
                gravityPoint.body_gravity_point.split(',').length == 2) {
                let graPointsStr = gravityPoint.body_gravity_point.split(',');
                let graX = Number(graPointsStr[0]) * expand;
                let graY = Number(graPointsStr[1]) * expand;
                result.gravity = [graX, graY];
                series.push({
                    data: [[graX, graY]],
                    type: 'scatter',
                    showSymbol: true,
                    symbolSize: 19,
                    hoverAnimation: false,
                    animation: false,
                    silent: true,
                    itemStyle: {
                        borderWidth: 2,
                        borderColor: 'red',
                    },
                });
                series.push({
                    data: [[graX, graY]],
                    type: 'scatter',
                    showSymbol: true,
                    symbolSize: 7,
                    hoverAnimation: false,
                    animation: false,
                    silent: true,
                    itemStyle: {
                        borderWidth: 7,
                        borderColor: 'red',
                    },
                });
            }
            // 左脚重心
            if (gravityPoint.left_gravity_point && gravityPoint.left_gravity_point.split(',') &&
                gravityPoint.left_gravity_point.split(',').length == 2) {
                let graPointsStr = gravityPoint.left_gravity_point.split(',');
                let leftGraX = Number(graPointsStr[0]) * expand;
                let leftGraY = Number(graPointsStr[1]) * expand;
                series.push({
                    data: [[leftGraX, leftGraY]],
                    type: 'scatter',
                    showSymbol: true,
                    symbolSize: 15,
                    hoverAnimation: false,
                    animation: false,
                    silent: true,
                    itemStyle: {
                        borderWidth: 2,
                        borderColor: 'red',
                    },
                });
                series.push({
                    data: [[leftGraX, leftGraY]],
                    type: 'scatter',
                    showSymbol: true,
                    symbolSize: 5,
                    hoverAnimation: false,
                    animation: false,
                    silent: true,
                    itemStyle: {
                        borderWidth: 5,
                        borderColor: 'red',
                    },
                });
            }
            // 右脚重心
            if (gravityPoint.right_gravity_point && gravityPoint.right_gravity_point.split(',') &&
                gravityPoint.right_gravity_point.split(',').length == 2) {
                let graPointsStr = gravityPoint.right_gravity_point.split(',');
                let rightGraX = Number(graPointsStr[0]) * expand;
                let rightGraY = Number(graPointsStr[1]) * expand;
                series.push({
                    data: [[rightGraX, rightGraY]],
                    type: 'scatter',
                    showSymbol: true,
                    symbolSize: 15,
                    hoverAnimation: false,
                    animation: false,
                    silent: true,
                    itemStyle: {
                        borderWidth: 2,
                        borderColor: 'red',
                    },
                });
                series.push({
                    data: [[rightGraX, rightGraY]],
                    type: 'scatter',
                    showSymbol: true,
                    symbolSize: 5,
                    hoverAnimation: false,
                    animation: false,
                    silent: true,
                    itemStyle: {
                        borderWidth: 5,
                        borderColor: 'red',
                    },
                });
            }
            let heatmapOption = {
                tooltip: {},
                grid: {
                    x: '0%',
                    y: '0%',
                    x2: '0%',
                    y2: '0%',
                    width: '100%',
                    height: '100%'
                },
                xAxis: {
                    show: false,
                    type: 'category',
                    data: xDra,
                    min: minX,
                    max: maxX,
                },
                yAxis: {
                    show: false,
                    type: 'category',
                    data: yDra,
                    min: minY,
                    max: maxY,
                },
                watchShallow: true,
                visualMap: {
                    min: 0,
                    max: 255,
                    show: false,
                    calculable: true,
                    realtime: false,
                    inRange: {
                        // color: ['#313695', '#4575b4', '#74add1', '#abd9e9', '#e0f3f8', '#ffffbf', '#fee090', '#fdae61', '#f46d43', '#d73027', '#a50026']
                        color: ['#0000ff', '#0040ff', '#0080ff', '#00c0ff', '#00ffc0', '#00ff80', '#00ff40', '#00ff00', '#80ff00', '#c0ff00', '#ffff00',
                            '#ffc000', '#ff8000', '#ff4000', '#ff0000', '#c00000']
                    }
                },
                series: series,
            };
            result.heatmapOption = heatmapOption;
        }
    }
    return result;
}

function getAreaPointList(footAreaStrList) {
    let pointsResult = [];

    areaNames.map(name => {
        if (footAreaStrList && footAreaStrList[name] && footAreaStrList[name].split('|').length == 4) {
            let points = [];
            let strList = footAreaStrList[name].split('|');
            let maxX = Number(strList[0].split(',')[0]) * expand;
            let minX = Number(strList[0].split(',')[0]) * expand;
            let maxY = Number(strList[0].split(',')[1]) * expand;
            let minY = Number(strList[0].split(',')[1]) * expand;
            strList.map(obj => {
                let x = Number(obj.split(',')[0]) * expand;
                let y = Number(obj.split(',')[1]) * expand;
                maxX = Math.max(maxX, x);
                minX = Math.min(minX, x);
                maxY = Math.max(maxY, y);
                minY = Math.min(minY, y);
                points.push([x, y]);
            })
            points.push(points[0]);
            pointsResult.push({name, points, center: [(maxX + minX) / 2, (maxY + minY) / 2]});
        }
    })
    return pointsResult;
}

export default {
    state,
    actions,
    mutations,
    getters,
}
